﻿;29-10-2023 07:00 start PNG
;30-10-2023 07:14 done JPG comments
;30-10-2023 07:49 drop file
;30-10-2023 16:31 found error detecting position on JPG, 17:04 fixed
;31-10-2023 06:18 another fix
;31-10-2023 07:59 new dojpg(), added check format, fixed PNG chunk check?
;31-10-2023 09:38 fix for getfile() - looking for comment
;01-11-2023 fixed comment replacement
;02-11-2023 12:00 fixed error finding existing comment replacement
;05-11-2023 9:35 added remove comment if string empty for JPG, skip for PNG
;06-11-2023 7:26 for JPG: done ANSI Cyrillic to Unicode
;06-11-2023 13:15 for JPG: replace wrong Cyrillic to Unicode
;23-11-2023 Set focus on text field comment
Global *m
Global i$,c$,w$
Global fs

Enumeration
  #fi
  #co
  #bu
EndEnumeration

Procedure.l Endian(x.l)
  ProcedureReturn (x & $FF) << 24 + (x & $FF00) << 8 + (x >> 8) & $FF00 + (x >> 24) & $FF
  ;Debug Endian(32) ; 536870912
  ;   !MOV eax, dword[p.v_x]
  ;   !BSWAP eax                  ; 32 bit little endian <-> big endian
  ;   ProcedureReturn             ; eax is returned by default
EndProcedure

Procedure.u swapby(va.u)
  ProcedureReturn ((va&$FF)<<8)|((va>>8)&$FF)
EndProcedure

Procedure wrbackup()
  If CopyFile(w$,i$)
    DeleteFile(w$)
  Else
    MessageRequester("File error!","error write"+#CRLF$+i$+#CRLF$+"write to"+#CRLF$+w$)
  EndIf
EndProcedure

Procedure dopng()
  
  r$="not written"
  If c$<>""
    ;look for IEND
    For i=0 To fs-1
      If PeekS(*m+i,4,#PB_Ascii)="IEND" And PeekL(*m+i-4)=0
        ;try To write comment
        If CreateFile(0,w$)
          ;write the rest
          WriteData(0,*m, i-4)
          ;determine len
          *b=AllocateMemory(Len(c$)*2)
          sl=PokeS(*b,c$,-1,#PB_UTF8)
          FreeMemory(*b)
          ;write length of field 7+5+len(c$)
          WriteLong( 0,Endian( 7+5+sl ) )
          ;write iTXtComment
          WriteString(0,"iTXtComment",#PB_Ascii)
          ;write 5 zero
          WriteLong(0,0)
          WriteAsciiCharacter(0,0)
          ;write utf8 encoded comment
          WriteString(0,c$,#PB_UTF8)
          ;write crc32 from iTXt to comment
          *b=AllocateMemory(16+Len(c$)*2)
          rl=PokeS(*b,"iTXtComment",11,#PB_Ascii)
          rl=PokeS(*b+rl+5,c$,-1,#PB_UTF8)
          cc=CRC32Fingerprint(*b,11+5+rl)
          WriteLong(0,Endian(cc))
          FreeMemory(*b)
          ;write rest of memory
          WriteData(0,*m+i-4,fs-i+4)
          CloseFile(0)
          wrbackup()
          r$="Done"
        Else
          MessageRequester("Write error!",w$)
        EndIf;If CreateFile(0,w$)
        StatusBarText(0, 0, r$)
        Break
      EndIf;If PeekS(*m+i,4,#PB_Ascii)="IEND"
    Next i
  Else
    StatusBarText(0, 0, "Empty comment not added")
  EndIf;If c$<>""
EndProcedure

Procedure dojpg()
  ;If CreateFile(0,w$)
  
  putpos=-1
  ;find comment
  comment_found=0
  i=0
  While i<fs
    marker.u=PeekU(*m+i)
    If marker<>$D8FF
      dd=swapby(PeekU(*m+i+2))+2
    Else
      dd=2
    EndIf
    ;    Debug Hex(marker)+","+Str(dd)
    If marker=$FEFF
      comment_found=1
      putpos=i
      Break
    EndIf
    If marker=$D9FF
      Break
    EndIf
    i+dd
  Wend
  ;look for proper position
  If comment_found=0
    i=0
    While i<fs
      marker.u=PeekU(*m+i)
      If marker<>$D8FF
        dd=swapby(PeekU(*m+i+2))+2
      Else
        dd=2
      EndIf
      ;Debug Hex(marker)
      If (marker>=$C0FF And marker<=$C7FF) Or marker=$DAFF
        putpos=i
        Break
        ;Else
      EndIf;(marker>=$C0FF Or marker<=$C7FF) Or marker=$DAFF
      i+dd
    Wend
  EndIf;comment_found=0
       ;if found proper position
  If putpos<>-1
    If CreateFile(0,w$)
      i=putpos
      If marker=$FEFF
        StatusBarText(0, 0, "Comment replaced", #PB_StatusBar_BorderLess)
        WriteData(0,*m,i)
        If c$<>""
          ;write warker
          WriteWord(0,$FEFF)
          ;write length of string
          ls=Len(c$)
          WriteWord(0,swapby(ls+2))
          WriteString(0,c$,#PB_Ascii)
        Else
          StatusBarText(0, 0, "Comment removed", #PB_StatusBar_BorderLess)
        EndIf
        ;skip comment,write rest
        ls=swapby(PeekU(*m+i+2))
        ;WriteData(0,*m+i+ls-2,fs-i-ls+2)
        WriteData(0,*m+i+ls+2,fs-i-ls-2)
        ;        StatusBarText(0, 0, "Comment replaced", #PB_StatusBar_BorderLess)
      Else
        WriteData(0,*m,i)
        WriteWord(0,$feff)
        WriteWord(0,swapby(Len(c$)+2))
        WriteString(0,c$,#PB_Ascii)
        WriteData(0,*m+i,fs-i)
        StatusBarText(0, 0, "Done", #PB_StatusBar_BorderLess)
      EndIf
      CloseFile(0)
      wrbackup()
    Else
      MessageRequester("Write error!",w$)
    EndIf;If CreateFile(0,w$)
  Else
    StatusBarText(0, 0, "Not added", #PB_StatusBar_BorderLess)
  EndIf;If putpos<>-1
EndProcedure

Procedure getfile(f$)
  SetGadgetText(#co,"")
  SetActiveGadget(#co)
  If LCase(GetExtensionPart(f$))="png"
    SetGadgetText(#fi,f$)
  EndIf
  If LCase(GetExtensionPart(f$))="jpg" Or LCase(GetExtensionPart(f$))="jpeg"
    SetGadgetText(#fi,f$)
    fs=FileSize(f$)
    If fs>=0
      *m=AllocateMemory(fs)
      If *m
        If ReadFile(0,f$)
          ReadData(0,*m,fs)
          CloseFile(0)
          If PeekU(*m)=$D8FF
            i=0
            While i<fs
              marker.u=PeekU(*m+i)
              i=i+2
              ;Debug Hex(marker)
              If marker=$D9FF
                Break
              EndIf
              If marker=$FEFF
                ls=swapby(PeekU(*m+i))-2
                ;convert Cyr ANSI to Unicode
                co$=""
                If ls
                  For n=0 To ls-1
                    cha.u=PeekA(*m+i+2+n)
                    For j=0 To 65
                      If cha=PeekU(?w1251+j*4)
                        cha=PeekU(?w1251+j*4+2)
                        Break
                      EndIf
                    Next j
                    co$=co$+Chr(cha)
                  Next n
                EndIf
                SetGadgetText(#co,co$)
                ;SetGadgetText(#co,PeekS(*m+i+2,ls,#PB_Ascii))
                Break
              ElseIf marker<>$D8FF
                dd=swapby(PeekU(*m+i))
                i=i+dd
              EndIf
            Wend
          Else
            MessageRequester("Image Commenter","Seems not JPG")
            SetGadgetText(#fi,"")
          EndIf;If PeekU(*m)=$D8FF
          
        EndIf
      EndIf
      FreeMemory(*m)
    EndIf
  EndIf
EndProcedure

If OpenWindow(0, 0, 0, 640, 480, "Image Commenter 0.9", #PB_Window_SystemMenu | #PB_Window_ScreenCentered|#PB_Window_MinimizeGadget)
  StringGadget(#fi, 0,  0, 640, 20, ""):GadgetToolTip(#fi,"path to image file")
  StringGadget(#co, 0,  20, 640, 420, "",#ES_MULTILINE|#ESB_DISABLE_BOTH):GadgetToolTip(#co,"Comment to file")
  ButtonGadget(#bu,0,440,640,20,"Write to file"):GadgetToolTip(#bu,"write comment to image file")
  EnableGadgetDrop(#co,#PB_Drop_Files,#PB_Drag_Copy)
  ;Debug GetSystemMetrics_(#SM_CYMENU)
  If CreateStatusBar(0, WindowID(0))
    AddStatusBarField(640)
    StatusBarText(0, 0, "Ready", #PB_StatusBar_BorderLess)
  EndIf
  
  If CountProgramParameters()
    getfile(ProgramParameter(0))
  EndIf
  ;SetGadgetText(#co,"«Маша и банник» Александр Дудин")
  Repeat
    ev=WaitWindowEvent()
    If GetAsyncKeyState_(#VK_ESCAPE)&32768
      Break
    EndIf
    Select ev
      Case #PB_Event_GadgetDrop
        getfile(StringField(EventDropFiles(),1,Chr($0A)))
      Case #PB_Event_Gadget
        Select EventGadget()
          Case #bu
            i$=GetGadgetText(#fi)
            c$=GetGadgetText(#co)
            ;check if field empty
            ;If c$<>""
            If i$<>""
              w$=GetPathPart(i$)+"backup-"+GetFilePart(i$)
              fs=FileSize(i$)
              If fs>=0
                *m=AllocateMemory(fs)
                If *m
                  If ReadFile(0,i$)
                    ReadData(0,*m,fs)
                    CloseFile(0)
                    StatusBarText(0, 0, "", #PB_StatusBar_BorderLess)
                    ex$=LCase(GetExtensionPart(i$))
                    If ex$="png"
                      ;SetGadgetText(#co,"")
                      dopng()
                    ElseIf ex$="jpg" Or ex$="jpeg"
                      If PeekU(*m)=$D8FF
                        ;fix wrong Unicode Cyrillic letters
                        c$=ReplaceString(c$,Chr($438)+Chr($306),Chr(1081));й
                        c$=ReplaceString(c$,Chr($435)+Chr($308),Chr($451));ё
                        c$=ReplaceString(c$,Chr($418)+Chr($306),Chr(1049));Й
                                                                          ;greek letters
                        c$=ReplaceString(c$,Chr(913),Chr(1040))           ;A
                        c$=ReplaceString(c$,Chr(914),Chr(1042))           ;B
                        c$=ReplaceString(c$,Chr(915),Chr(1043))           ;Г
                        c$=ReplaceString(c$,Chr(917),Chr(1045))           ;E
                        c$=ReplaceString(c$,Chr(919),Chr(1053))           ;H
                        c$=ReplaceString(c$,Chr(922),Chr(1050))           ;K
                        c$=ReplaceString(c$,Chr(923),Chr(1051))           ;Л
                        c$=ReplaceString(c$,Chr(927),Chr(1054))           ;O
                        c$=ReplaceString(c$,Chr(928),Chr(1055))           ;П
                        c$=ReplaceString(c$,Chr(929),Chr(1056))           ;P
                        c$=ReplaceString(c$,Chr(932),Chr(1058))           ;T
                        c$=ReplaceString(c$,Chr(935),Chr(1061))           ;X
                        c$=ReplaceString(c$,Chr(924),Chr(1052))           ;М
                        dojpg()
                      Else
                        MessageRequester("Image Commenter","Seems not JPG")
                      EndIf;If PeekU(*m=$D8FF)
                    Else
                      MessageRequester("Image Commenter","Only PNG/JPG support")
                    EndIf
                  Else
                    MessageRequester("File error!","Error read "+i$)
                  EndIf;If ReadFile(0,i$)
                  FreeMemory(*m)
                Else
                  MessageRequester("Memory error!","Can't allocate "+Str(fs))
                EndIf; if *m
              Else
                MessageRequester("File error!",i$)
              EndIf ;If fs>=0
            Else
              MessageRequester("write comment","no file to write")
            EndIf ;If I$<>""
                  ;             Else
                  ;               MessageRequester("write comment","Empty comment")
                  ;             EndIf ;If c$<>""
        EndSelect
    EndSelect
  Until ev= #PB_Event_CloseWindow
EndIf


DataSection
  w1251:
  Data.u $C0,$0410;А 1
  Data.u $C1,$0411;Б 2
  Data.u $C2,$0412;В 3
  Data.u $C3,$0413;Г 4
  Data.u $C4,$0414;Д 5
  Data.u $C5,$0415;Е 6
  Data.u $A8,$0401;Ё 7
  Data.u $C6,$0416;Ж 8
  Data.u $C7,$0417;З 9
  Data.u $C8,$0418;И 10
  Data.u $C9,$0419;Й 11
  Data.u $CA,$041A;К 12
  Data.u $CB,$041B;Л 13
  Data.u $CC,$041C;М 14
  Data.u $CD,$041D;Н 15
  Data.u $CE,$041E;О 16
  Data.u $CF,$041F;П 17
  Data.u $D0,$0420;Р 18
  Data.u $D1,$0421;С 19
  Data.u $D2,$0422;Т 20
  Data.u $D3,$0423;У 21
  Data.u $D4,$0424;Ф 22
  Data.u $D5,$0425;Х 23
  Data.u $D6,$0426;Ц 24
  Data.u $D7,$0427;Ч 25
  Data.u $D8,$0428;Ш 26
  Data.u $D9,$0429;Щ 27
  Data.u $DA,$042A;Ъ 28
  Data.u $DB,$042B;Ы 29
  Data.u $DC,$042C;Ь 30
  Data.u $DD,$042D;Э 31
  Data.u $DE,$042E;Ю 32
  Data.u $DF,$042F;Я 33
  Data.u $E0,$0430;а 34
  Data.u $E1,$0431;б 35
  Data.u $E2,$0432;в 36
  Data.u $E3,$0433;г 37
  Data.u $E4,$0434;д 38
  Data.u $E5,$0435;е 39
  Data.u $B8,$0451;ё 40
  Data.u $E6,$0436;ж 41
  Data.u $E7,$0437;з 42
  Data.u $E8,$0438;и 43
  Data.u $E9,$0439;й 44
  Data.u $EA,$043A;к 45
  Data.u $EB,$043B;л 46
  Data.u $EC,$043C;м 47
  Data.u $ED,$043D;н 48
  Data.u $EE,$043E;о 49
  Data.u $EF,$043F;п 50
  Data.u $F0,$0440;р 51
  Data.u $F1,$0441;с 52
  Data.u $F2,$0442;т 53
  Data.u $F3,$0443;у 54
  Data.u $F4,$0444;ф 55
  Data.u $F5,$0445;х 56
  Data.u $F6,$0446;ц 57
  Data.u $F7,$0447;ч 58
  Data.u $F8,$0448;ш 59
  Data.u $F9,$0449;щ 60
  Data.u $FA,$044A;ъ 61
  Data.u $FB,$044B;ы 62
  Data.u $FC,$044C;ь 63
  Data.u $FD,$044D;э 64
  Data.u $FE,$044E;ю 65
  Data.u $FF,$044F;я 66

; IDE Options = PureBasic 5.30 (Windows - x86)
; CursorPosition = 177
; FirstLine = 172
; Folding = --
; EnableUnicode
; EnableXP
; UseIcon = imcom.ico
; Executable = imgcom.exe
; CommandLine = MSK.jpeg